//Пример проверки работоспособности max6675

//---MAX6675 functions---//
double max6675_read_temp (int CLK, int CS, int SO)
{ char i;
  int tmp = 0;
  digitalWrite(CS, LOW); //CS = 0;                            //Stop a conversion in progress
  asm volatile
  (
    " nop"        "\n\t"
  );
  for (i = 15; i >= 0; i--)
  { digitalWrite(CLK, HIGH);
    asm volatile
    (
      " nop"        "\n\t"
    );
    if ( digitalRead(SO))
      tmp |= (1 << i);


    digitalWrite(CLK, LOW);
    asm volatile
    (
      " nop"        "\n\t"
    );
  }
  digitalWrite(CS, HIGH);
  if (tmp & 0x4) {
    return NAN;
  } else
    return ((tmp >> 3)) * 0.25;
}
//---MAX6675 functions---//

//---назначаем пины преобразователя сигнала термопары---//
#define thermoCLK  9 //SCK=(CLK) MAX6675
#define thermoCS  8 //CS MAX6675
#define thermoSO  7 //DO=(SO) MAX6675

void setup() {
  Serial.begin(9600);

  //---задаём состояние пинов, к которым подключены MAX6675---//
  pinMode(thermoCS, OUTPUT);
  pinMode(thermoCLK, OUTPUT);
  pinMode(thermoSO, INPUT);

  Serial.println("MAX6675 life");
  delay(3000);
}

void loop() 
{
  //Выводим показания в монитор порта
  Serial.print( " C = " );
  Serial.println(max6675_read_temp(thermoCLK, thermoCS, thermoSO));
  delay(1000);
}
